<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    <p>{{ error }}</p>
  </base-dialog>
  <base-card v-if="error === null">
    <h1>{{ selectedWork["topic"] }}</h1>
    <h2>
      Termin: {{ showOpenDate }} -
      {{ showCloseDate }}
    </h2>
    <p>{{ selectedWork["description"] }}</p>
    <ul>
      <submitted-work
        v-for="submit in selectedWork['submits']"
        :key="submit['userId']"
        :user-email="submit['userEmail']"
        :date-time="submit['dateTime']['date']"
        :file-path="submit['filePath']"
        :file-type="submit['fileType']"
      ></submitted-work>
    </ul>
  </base-card>
</template>

<script setup>
import SubmittedWork from "@/components/SubmittedWork.vue";

import { ref, defineProps, computed } from "vue";
import { useStore } from "vuex";
import router from "@/router";

const store = useStore();
const props = defineProps(["id"]);

const selectedWork = ref(null);
const error = ref(null);

function handleError() {
  error.value = null;
}

const showOpenDate = computed(function () {
  const date = selectedWork.value["openDate"];
  return (
    date.substring(8, 10) +
    "." +
    date.substring(5, 7) +
    "." +
    date.substring(0, 4)
  );
});
const showCloseDate = computed(function () {
  const date = selectedWork.value["closeDate"];
  return (
    date.substring(8, 10) +
    "." +
    date.substring(5, 7) +
    "." +
    date.substring(0, 4)
  );
});

try {
  selectedWork.value = store.getters.works.find(
    (work) => work["id"] === props.id
  );
  if (
    selectedWork.value["userUuId"].toString() !==
    store.getters.userId.toString()
  ) {
    router.replace("/works");
  }
} catch (e) {
  error.value = "Nie udało się załadować danych.";
}

if (selectedWork.value === undefined) {
  router.replace("/works");
}
</script>
